Loading...
Searching...
No Matches
CglTreeProbingInfo Class Reference

`#include <CglTreeInfo.hpp>`

Inheritance diagram for CglTreeProbingInfo:
[legend]
Collaboration diagram for CglTreeProbingInfo:
[legend]

## Public Member Functions

| CglTreeProbingInfo ()
| Default constructor.
| CglTreeProbingInfo (const OsiSolverInterface *model)
| Constructor from model.
| CglTreeProbingInfo (const CglTreeProbingInfo &)
| Copy constructor.
virtual CglTreeInfo * | clone () const
| Clone.
CglTreeProbingInfo & | operator= (const CglTreeProbingInfo &rhs)
| Assignment operator.
virtual | ~CglTreeProbingInfo ()
| Destructor.
OsiSolverInterface * | analyze (const OsiSolverInterface &si, int createSolver=0, int numberExtraCliques=0, const CoinBigIndex *starts=NULL, const CliqueEntry *entries=NULL, const char *type=NULL)
virtual bool | fixes (int variable, int toValue, int fixedVariable, bool fixedToLower)
| Take action if cut generator can fix a variable (toValue -1 for down, +1 for up) Returns true if still room, false if not.
virtual int | initializeFixing (const OsiSolverInterface *model)
| Initalizes fixing arrays etc - returns >0 if we want to save info 0 if we don't and -1 if is to be used.
int | fixColumns (OsiSolverInterface &si) const
| Fix entries in a solver using implications.
int | fixColumns (int iColumn, int value, OsiSolverInterface &si) const
| Fix entries in a solver using implications for one variable.
int | packDown ()
| Packs down entries.
void | generateCuts (const OsiSolverInterface &si, OsiCuts &cs, const CglTreeInfo info) const
| Generate cuts from implications.
CliqueEntry * | fixEntries ()
| Entries for fixing variables.
int * | toZero ()
| Starts of integer variable going to zero.
int * | toOne ()
| Starts of integer variable going to one.
int * | integerVariable () const
| List of 0-1 integer variables.
int * | backward () const
| Backward look up.
int | numberVariables () const
| Number of variables.
int | numberIntegers () const
| Number of 0-1 variables.
Public Member Functions inherited from CglTreeInfo
| CglTreeInfo ()
| Default constructor.
| CglTreeInfo (const CglTreeInfo &)
| Copy constructor.
CglTreeInfo & | operator= (const CglTreeInfo &rhs)
| Assignment operator.
virtual | ~CglTreeInfo ()
| Destructor.

## Protected Attributes

CliqueEntry * | fixEntry_
| Entries for fixing variables.
int * | toZero_
| Starts of integer variable going to zero.
int * | toOne_
| Starts of integer variable going to one.
int * | integerVariable_
| List of 0-1 integer variables.
int * | backward_
| Backward look up.
int * | fixingEntry_
| Entries for fixing variable when collecting.
int | numberVariables_
| Number of variables.
int | numberIntegers_
| Number of 0-1 variables.
int | maximumEntries_
| Maximum number in fixEntry_.
int | numberEntries_
| Number entries in fixingEntry_ (and fixEntry_) or -2 if correct style.

## Private Member Functions

void | convert ()
| Converts to ordered.

## Additional Inherited Members

Public Attributes inherited from CglTreeInfo
int | level
| The level of the search tree node.
int | pass
| How many times the cut generator was already invoked in this search tree node.
int | formulation_rows
| The number of rows in the original formulation.
int | options

Options 1 - treat costed integers as important 2 - switch off some stuff as variables semi-integer 4 - set global cut flag if at root node 8 - set global cut flag if at root node and first pass 16 - set global cut flag and make cuts globally valid 32 - last round of cuts did nothing - maybe be more aggressive 64 - in preprocessing stage 128 - looks like solution 256 - want alternate cuts 512 - in sub tree (i.e.

bool | inTree
| Set true if in tree (to avoid ambiguity at first branch).
int | hasParent
| nonzero if called from child of main model 1 if heuristic run 2 if doing full search
OsiSolverInterface * | parentSolver
| parent solver
int * | originalColumns
| Original columns (if preprocessed).
OsiRowCut ** | strengthenRow
| Replacement array.
CoinThreadRandom * | randomNumberGenerator
| Optional pointer to thread specific random number generator.

## Detailed Description

Definition at line 92 of file CglTreeInfo.hpp.

## Constructor & Destructor Documentation

## CglTreeProbingInfo() [1/3]

CglTreeProbingInfo::CglTreeProbingInfo | ( |  | ) |

Default constructor.

## CglTreeProbingInfo() [2/3]

CglTreeProbingInfo::CglTreeProbingInfo | ( | const OsiSolverInterface * | model | ) |

Constructor from model.

## CglTreeProbingInfo() [3/3]

CglTreeProbingInfo::CglTreeProbingInfo | ( | const CglTreeProbingInfo & |  | ) |

Copy constructor.

## ~CglTreeProbingInfo()

virtual CglTreeProbingInfo::~CglTreeProbingInfo | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## clone()

virtual CglTreeInfo * CglTreeProbingInfo::clone | ( |  | ) | const

virtual

Clone.

Reimplemented from CglTreeInfo.

## operator=()

CglTreeProbingInfo & CglTreeProbingInfo::operator= | ( | const CglTreeProbingInfo & | rhs | ) |

Assignment operator.

## analyze()

OsiSolverInterface * CglTreeProbingInfo::analyze | ( | const OsiSolverInterface & | si,
|  | int | createSolver = 0,
|  | int | numberExtraCliques = 0,
|  | const CoinBigIndex * | starts = NULL,
|  | const CliqueEntry * | entries = NULL,
|  | const char * | type = NULL )

## fixes()

virtual bool CglTreeProbingInfo::fixes | ( | int | variable,
|  | int | toValue,
|  | int | fixedVariable,
|  | bool | fixedToLower )

virtual

Take action if cut generator can fix a variable (toValue -1 for down, +1 for up) Returns true if still room, false if not.

Reimplemented from CglTreeInfo.

## initializeFixing()

virtual int CglTreeProbingInfo::initializeFixing | ( | const OsiSolverInterface * | model | ) |

virtual

Initalizes fixing arrays etc - returns >0 if we want to save info 0 if we don't and -1 if is to be used.

Reimplemented from CglTreeInfo.

## fixColumns() [1/2]

int CglTreeProbingInfo::fixColumns | ( | OsiSolverInterface & | si | ) | const

Fix entries in a solver using implications.

## fixColumns() [2/2]

int CglTreeProbingInfo::fixColumns | ( | int | iColumn,
|  | int | value,
|  | OsiSolverInterface & | si ) const

Fix entries in a solver using implications for one variable.

## packDown()

int CglTreeProbingInfo::packDown | ( |  | ) |

Packs down entries.

## generateCuts()

void CglTreeProbingInfo::generateCuts | ( | const OsiSolverInterface & | si,
|  | OsiCuts & | cs,
|  | const CglTreeInfo | info ) const

Generate cuts from implications.

## fixEntries()

CliqueEntry * CglTreeProbingInfo::fixEntries | ( |  | ) |

inline

Entries for fixing variables.

Definition at line 132 of file CglTreeInfo.hpp.

## toZero()

int * CglTreeProbingInfo::toZero | ( |  | ) |

inline

Starts of integer variable going to zero.

Definition at line 138 of file CglTreeInfo.hpp.

## toOne()

int * CglTreeProbingInfo::toOne | ( |  | ) |

inline

Starts of integer variable going to one.

Definition at line 144 of file CglTreeInfo.hpp.

## integerVariable()

int * CglTreeProbingInfo::integerVariable | ( |  | ) | const

inline

List of 0-1 integer variables.

Definition at line 150 of file CglTreeInfo.hpp.

## backward()

int * CglTreeProbingInfo::backward | ( |  | ) | const

inline

Backward look up.

Definition at line 155 of file CglTreeInfo.hpp.

## numberVariables()

int CglTreeProbingInfo::numberVariables | ( |  | ) | const

inline

Number of variables.

Definition at line 160 of file CglTreeInfo.hpp.

## numberIntegers()

int CglTreeProbingInfo::numberIntegers | ( |  | ) | const

inline

Number of 0-1 variables.

Definition at line 165 of file CglTreeInfo.hpp.

## convert()

void CglTreeProbingInfo::convert | ( |  | ) |

private

Converts to ordered.

## Member Data Documentation

## fixEntry_

CliqueEntry* CglTreeProbingInfo::fixEntry_

protected

Entries for fixing variables.

Definition at line 176 of file CglTreeInfo.hpp.

## toZero_

int* CglTreeProbingInfo::toZero_

protected

Starts of integer variable going to zero.

Definition at line 178 of file CglTreeInfo.hpp.

## toOne_

int* CglTreeProbingInfo::toOne_

protected

Starts of integer variable going to one.

Definition at line 180 of file CglTreeInfo.hpp.

## integerVariable_

int* CglTreeProbingInfo::integerVariable_

protected

List of 0-1 integer variables.

Definition at line 182 of file CglTreeInfo.hpp.

## backward_

int* CglTreeProbingInfo::backward_

protected

Backward look up.

Definition at line 184 of file CglTreeInfo.hpp.

## fixingEntry_

int* CglTreeProbingInfo::fixingEntry_

protected

Entries for fixing variable when collecting.

Definition at line 186 of file CglTreeInfo.hpp.

## numberVariables_

int CglTreeProbingInfo::numberVariables_

protected

Number of variables.

Definition at line 188 of file CglTreeInfo.hpp.

## numberIntegers_

int CglTreeProbingInfo::numberIntegers_

protected

Number of 0-1 variables.

Definition at line 190 of file CglTreeInfo.hpp.

## maximumEntries_

int CglTreeProbingInfo::maximumEntries_

protected

Maximum number in fixEntry_.

Definition at line 192 of file CglTreeInfo.hpp.

## numberEntries_

int CglTreeProbingInfo::numberEntries_

protected

Number entries in fixingEntry_ (and fixEntry_) or -2 if correct style.

Definition at line 194 of file CglTreeInfo.hpp.

The documentation for this class was generated from the following file:

- Cgl/src/CglTreeInfo.hpp